package org.wfc.user.api.factory;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;
import org.springframework.web.multipart.MultipartFile;
import org.wfc.common.core.domain.R;
import org.wfc.user.api.RemoteUFileService;
import org.wfc.user.api.domain.UFile;

/**
 * 文件服务降级处理
 * 
 * @author wfc
 */
@Component
public class RemoteUFileFallbackFactory implements FallbackFactory<RemoteUFileService>
{
    private static final Logger log = LoggerFactory.getLogger(RemoteUFileFallbackFactory.class);

    @Override
    public RemoteUFileService create(Throwable throwable)
    {
        log.error("File service call failed:{}", throwable.getMessage());
        return new RemoteUFileService()
        {
            @Override
            public R<UFile> upload(MultipartFile file)
            {
                return R.fail("Failed to upload file:" + throwable.getMessage());
            }
        };
    }
}
